
package require BLT
source scripts/demo.tcl

set pictures [glob -nocomplain "*.jpg"]
set autocolors {
#0000cd
#cd0000
#00cd00
#3a5fcd
#cdcd00
#cd1076
#009acd
#00c5cd
#a2b5cd
#7ac5cd
#66cdaa
#a2cd5a
#cd9b9b
#cdba96
#cd3333
#cd6600
#cd8c95
#cd00cd
#9a32cd
#6ca6cd
#9ac0cd
#9bcd9b
#00cd66
#cdc673
#cdad00
#cd5555
#cd853f
#cd7054
#cd5b45
#cd6889
#cd69c9
#551a8b
}

proc Move { w pane } {
#    puts stderr "w=$w pane=$pane"
    .fs see $pane
}

blt::filmstrip .fs  -width 600 -scrollcommand { .s set } \
    -scrolldelay 10 -scrollincrement 30 -animate yes


for { set i 0 } { $i < 32 } { incr i } {
    set color [lindex $autocolors $i]
    blt::graph .fs.g$i -bg $color -width 500
    set pane [.fs add -window .fs.g$i -fill x -showhandle yes]
    bind .fs.g$i <ButtonPress-1>  [list Move %W $pane]
    bind .fs.g$i <ButtonPress-2>  [list Move %W 0]
    bind .fs.g$i <ButtonPress-3>  [list Move %W end]
}
blt::tk::scrollbar .s -command { .fs view } -orient horizontal

blt::table . \
    0,0 .fs -fill both \
    1,0 .s -fill x 

blt::table configure . r1 -resize none
focus .fs

