/*
 * tclIntPlatDecls.h --
 *
 * This file contains the declarations for all platform dependent
 * unsupported functions that are exported by the TCL library.  These
 * * interfaces are not guaranteed to remain the same between
 * versions.  Use at your own risk.
 *
 *	Copyright 2003-2004 George A Howlett.
 *
 *	Permission is hereby granted, free of charge, to any person
 *	obtaining a copy of this software and associated documentation
 *	files (the "Software"), to deal in the Software without
 *	restriction, including without limitation the rights to use,
 *	copy, modify, merge, publish, distribute, sublicense, and/or
 *	sell copies of the Software, and to permit persons to whom the
 *	Software is furnished to do so, subject to the following
 *	conditions:
 *
 *	The above copyright notice and this permission notice shall be
 *	included in all copies or substantial portions of the
 *	Software.
 *
 *	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
 *	KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 *	WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 *	PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
 *	OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 *	OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 *	OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *	SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * This file was adapted from tclIntPlatDecls.h of the TCL library distribution.
 *
 *	Copyright (c) 1998-1999 by Scriptics Corporation.  All rights
 *	reserved.
 *
 */

#ifndef _TCLINTPLATDECLS
#define _TCLINTPLATDECLS

/*
 * WARNING: This file is automatically generated by the tools/genStubs.tcl
 * script.  Any modifications to the function declarations below should be made
 * in the generic/tclInt.decls script.
 */

/* !BEGIN!: Do not edit below this line. */

/*
 * Exported function declarations:
 */

#ifdef __WIN32__
/* 0 */
extern void TclWinConvertError(DWORD errCode);

/* 4 */
extern HINSTANCE TclWinGetTclInstance(void);
#endif /* __WIN32__ */

typedef struct TclIntPlatStubs {
    int magic;
    struct TclIntPlatStubHooks *hooks;

#ifdef WIN32
    void (*tclWinConvertError)(DWORD errCode); /* 0 */
#else
    void *hook0;
#endif
    void *hook1;
    void *hook2;
    void *hook3;
#ifdef WIN32
    HINSTANCE (*tclWinGetTclInstance)(void); /* 4 */
#else
    void *hook4;
#endif
    void *hook5;
    void *hook6;
    void *hook7;
    void *hook8;
    void *hook9;
    void *hook10;
    void *hook11;
    void *hook12;
    void *hook13;
    void *hook14;
    void *hook15;
    void *hook16;
    void *hook17;
    void *hook18;
    void *hook19;
    void *hook20;
    void *hook21;
    void *hook22;
    void *hook23;
    void *hook24;
    void *hook25;

} TclIntPlatStubs;

#ifdef __cplusplus
extern "C" {
#endif
extern TclIntPlatStubs *tclIntPlatStubsPtr;
#ifdef __cplusplus
}
#endif

#if defined(USE_TCL_STUBS) && !defined(USE_TCL_STUB_PROCS)

/*
 * Inline function declarations:
 */

#ifdef __WIN32__
#ifndef TclWinConvertError
#define TclWinConvertError \
	(tclIntPlatStubsPtr->tclWinConvertError) /* 0 */
#endif
#ifndef TclWinGetTclInstance
#define TclWinGetTclInstance \
	(tclIntPlatStubsPtr->tclWinGetTclInstance) /* 4 */
#endif
#endif /* __WIN32__ */

#endif /* defined(USE_TCL_STUBS) && !defined(USE_TCL_STUB_PROCS) */

/* !END!: Do not edit above this line. */

#endif /* _TCLINTPLATDECLS */
