
/*
 * tkIntPlatDecls.h --
 *
 * This file contains the declarations for all platform dependent
 * unsupported functions that are exported by the Tk library. These
 * interfaces are not guaranteed to remain the same between versions.
 * Use at your own risk.
 *
 *	Copyright 2003-2004 George A Howlett.
 *
 *	Permission is hereby granted, free of charge, to any person
 *	obtaining a copy of this software and associated documentation
 *	files (the "Software"), to deal in the Software without
 *	restriction, including without limitation the rights to use,
 *	copy, modify, merge, publish, distribute, sublicense, and/or
 *	sell copies of the Software, and to permit persons to whom the
 *	Software is furnished to do so, subject to the following
 *	conditions:
 *
 *	The above copyright notice and this permission notice shall be
 *	included in all copies or substantial portions of the
 *	Software.
 *
 *	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
 *	KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 *	WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 *	PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
 *	OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 *	OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 *	OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *	SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * This file was adapted from tkIntPlatDecls.h of the Tk library distribution.
 *
 *	Copyright (c) 1998-1999 by Scriptics Corporation.
 *
 *	See the file "license.terms" for information on usage and
 *	redistribution of this file, and for a DISCLAIMER OF ALL
 *	WARRANTIES.
 */

#ifndef _TKINTPLATDECLS
#define _TKINTPLATDECLS

#ifdef BUILD_tk
#undef TCL_STORAGE_CLASS
#define TCL_STORAGE_CLASS DLLEXPORT
#endif

/*
 * WARNING: This file is automatically generated by the tools/genStubs.tcl
 * script.  Any modifications to the function declarations below should be made
 * in the generic/tkInt.decls script.
 */

/* !BEGIN!: Do not edit below this line. */

/*
 * Exported function declarations:
 */

#ifdef __WIN32__
/* 16 */
extern HDC TkWinGetDrawableDC(Display *display, Drawable drawable, 
	TkWinDCState *state);
/* 22 */
extern void TkWinReleaseDrawableDC(Drawable drawable, HDC hdc, 
	TkWinDCState *state);
#endif /* __WIN32__ */

typedef struct TkIntPlatStubs {
    int magic;
    struct TkIntPlatStubHooks *hooks;

    void *hook0;
    void *hook1;
    void *hook2;
    void *hook3;
    void *hook4;
    void *hook5;
    void *hook6;
    void *hook7;
    void *hook8;
    void *hook9;
    void *hook10;
    void *hook11;
    void *hook12;
    void *hook13;
    void *hook14;
    void *hook15;
#ifdef WIN32
    HDC (*tkWinGetDrawableDC)(Display *display, Drawable drawable, 
	TkWinDCState *state);	/* 16 */
#else 
    void *hook16;
#endif
    void *hook17;
    void *hook18;
    void *hook19;
    void *hook20;
    void *hook21;
#ifdef WIN32
    void (*tkWinReleaseDrawableDC)(Drawable drawable, HDC hdc, 
	TkWinDCState *state);	/* 22 */
#else
    void *hook22;
#endif
    void *hook23;
    void *hook24;
    void *hook25;
    void *hook26;
    void *hook27;
    void *hook28;
    void *hook29;
    void *hook30;
    void *hook31;
    void *hook32;
    void *hook33;
    void *hook34;
    void *hook35;
    void *hook36;
    void *hook37;
    void *hook38;
    void *hook39;
    void *hook40;
    void *hook41;
    void *hook42;
    void *hook43;
    void *hook44;
    void *hook45;
    void *hook46;
    void *hook47;
    void *hook48;
    void *hook49;
    void *hook50;
    void *hook51;
    void *hook52;
    void *hook53;
    void *hook54;
    void *hook55;
    void *hook56;
    void *hook57;
    void *hook58;
    void *hook59;
    void *hook60;
    void *hook61;
    void *hook62;
    void *hook63;
    void *hook64;
    void *hook65;
    void *hook66;
} TkIntPlatStubs;

#ifdef __cplusplus
extern "C" {
#endif
extern TkIntPlatStubs *tkIntPlatStubsPtr;
#ifdef __cplusplus
}
#endif

#if defined(USE_TK_STUBS) && !defined(USE_TK_STUB_PROCS)

/*
 * Inline function declarations:
 */
#ifdef __WIN32__
#ifndef TkWinGetDrawableDC
#define TkWinGetDrawableDC \
	(tkIntPlatStubsPtr->tkWinGetDrawableDC) /* 16 */
#endif
#ifndef TkWinReleaseDrawableDC
#define TkWinReleaseDrawableDC \
	(tkIntPlatStubsPtr->tkWinReleaseDrawableDC) /* 22 */
#endif
#endif /* __WIN32__ */

#endif /* defined(USE_TK_STUBS) && !defined(USE_TK_STUB_PROCS) */

/* !END!: Do not edit above this line. */

#undef TCL_STORAGE_CLASS
#define TCL_STORAGE_CLASS DLLIMPORT

#endif /* _TKINTPLATDECLS */
