// Copyright (C) 1999-2010
// Smithsonian Astrophysical Observatory, Cambridge, MA, USA
// For conditions of distribution and use, see copyright notice in "copyright"

#include "tcl.h"

#include "colorbartruecolor.h"
#include "util.h"

ColorbarTrueColor::ColorbarTrueColor(Tcl_Interp* i,Tk_Canvas c,Tk_Item* item) 
  : ColorbarBase(i,c,item), Colorbar(i,c,item), ColorbarTrue(i,c,item)
{
  colorCount = 0;
}

int ColorbarTrueColor::initColormap()
{
  colorCount = (((ColorbarBaseOptions*)options)->colors);

  colorIndex = new unsigned short[colorCount];
  for (int i=0; i<colorCount; i++)
    colorIndex[i] = i;
  colorCells = new unsigned char[colorCount*3];

  return TCL_OK;
}

void ColorbarTrueColor::updateColorCells()
{
  // fill rgb table
  // note: its filled bgr to match XImage

  if (currentcmap)
    for(int i=0, j=colorCount-1; i<colorCount; i++, j--) {
      int index = invert ? calcContrastBias(j) : calcContrastBias(i);
      colorCells[i*3] = currentcmap->getBlueChar(index, colorCount);
      colorCells[i*3+1] = currentcmap->getGreenChar(index, colorCount);
      colorCells[i*3+2] = currentcmap->getRedChar(index, colorCount);
    }
}


