// Copyright (C) 1999-2010
// Smithsonian Astrophysical Observatory, Cambridge, MA, USA
// For conditions of distribution and use, see copyright notice in "copyright"

#ifndef __circle3d_h__
#define __circle3d_h__

#include "baseellipse.h"

class Circle3d : public BaseEllipse {
 public:
  enum Method {SUM,AVERAGE};

 private:
  Method method;
  CoordSystem system;

 public:
  Circle3d(const Circle3d&);
  Circle3d(FrameBase* p, const Vector& ctr,
	       double r,
	       const char* mvcb, const char* delcb,
	       const char* clr, int *dsh,
	       int wth, const char* fnt, const char* txt, 
	       unsigned short prop, const char* cmt,
	       const List<Tag>& tg, const List<CallBack>& cb);

  Marker* dup() {return new Circle3d(*this);}
  void edit(const Vector&, int);

  void rotateBegin() {}
  void rotate(const Vector& v, int h) {}
  void rotateEnd() {}

  void setMethod(int);
  int getMethod() {return method;}

  CoordSystem getSystem() {return system;}
  void setSystem(CoordSystem sys) {system = sys;}

  void list(ostream&, CoordSystem, SkyFrame, SkyFormat, int, int);
  void listXML(ostream&, CoordSystem, SkyFrame, SkyFormat);

  // special composite funtionality
  void setComposite(const Matrix&, double);
};

#endif
