// Copyright (C) 1999-2010
// Smithsonian Astrophysical Observatory, Cambridge, MA, USA
// For conditions of distribution and use, see copyright notice in "copyright"

#ifndef __grid_h__
#define __grid_h__

#include <tk.h>

#include "gridbase.h"
#include "vector.h"
#include "coord.h"

class Grid : public GridBase {
 public:
  enum GridType {ANALYSIS,PUBLICATION};

 private:
  GridType type_;

  CoordSystem system_;
  SkyFrame sky_;
  SkyFormat skyFormat_;

 private:
  int doit(RenderMode);

  void* fits2ast();
  void* wcs2ast(void*);

  void putFitsCard(void*, const char*, const char*);
  void putFitsCard(void*, const char*, double);

 public:
  Grid(Widget*, CoordSystem, SkyFrame, SkyFormat, GridType, const char*);

  int render();
  int ps(int);
#ifdef _MACOSX
  int macosx();
#endif
#ifdef _WIN32
  int win32();
#endif

  CoordSystem system() {return system_;}
  SkyFrame sky() {return sky_;}
  SkyFormat skyFormat() {return skyFormat_;}
  GridType type() {return type_;}
};

#endif
