#  Copyright (C) 1999-2010
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc BoxDialog {varname} {
    upvar #0 $varname var
    global $varname

    # see if we already have a header window visible
    if [winfo exists $var(top)] {
	raise $var(top)
	return
    }

    # procs
    set var(which) box
    set var(proc,apply) BoxApply
    set var(proc,close) BoxClose
    set var(proc,coordCB) BoxCoordCB
    set var(proc,editCB) BoxEditCB
    set var(proc,distCB) BoxDistCB

    # base
    MarkerBaseRectDialog $varname 375 125 size
}

# actions

proc BoxClose {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBaseRectClose $varname
}

proc BoxApply {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBaseRectApply $varname
}

# callbacks

proc BoxCoordCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "BoxCoordCB"
    }

    MarkerBaseRectCoordCB $varname
}

proc BoxEditCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "BoxEditCB"
    }

    MarkerBaseRectEditCB $varname
}

proc BoxDistCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "BoxDistCB"
    }

    MarkerBaseRectDistCB $varname
}
