#  Copyright (C) 1999-2010
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc BoxAnnulusDialog {varname} {
    upvar #0 $varname var
    global $varname

    # see if we already have a header window visible
    if [winfo exists $var(top)] {
	raise $var(top)
	return
    }

    # procs
    set var(which) boxannulus
    set var(proc,apply) BoxAnnulusApply
    set var(proc,close) BoxAnnulusClose
    set var(proc,generate) BoxAnnulusGenerate
    set var(proc,coordCB) BoxAnnulusCoordCB
    set var(proc,editCB) BoxAnnulusEditCB
    set var(proc,distCB) BoxAnnulusDistCB

    # base
    MarkerBaseAnnulusRectDialog $varname 275 150 size Width Height
}

# actions

proc BoxAnnulusClose {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBaseAnnulusRectClose $varname
}

proc BoxAnnulusApply {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBaseAnnulusRectApply $varname
}

proc BoxAnnulusGenerate {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBaseAnnulusGenerateBox $varname
}

# callbacks

proc BoxAnnulusCoordCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "BoxAnnulusCoordCB"
    }

    MarkerBaseAnnulusRectCoordCB $varname
}

proc BoxAnnulusEditCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "BoxAnnulusEditCB"
    }

    MarkerBaseAnnulusRectEditCB $varname
}

proc BoxAnnulusDistCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "BoxAnnulusDistCB"
    }

    MarkerBaseAnnulusRectDistCB $varname
}
