#  Copyright (C) 1999-2010
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc BpandaDialog {varname} {
    upvar #0 $varname var
    global $varname

    # see if we already have a header window visible
    if [winfo exists $var(top)] {
	raise $var(top)
	return
    }

    # procs
    set var(which) bpanda
    set var(proc,apply) BpandaApply
    set var(proc,close) BpandaClose
    set var(proc,generate) BpandaGenerate
    set var(proc,coordCB) BpandaCoordCB
    set var(proc,editCB) BpandaEditCB
    set var(proc,distCB) BpandaDistCB

    # base panda rect dialog
    MarkerBasePandaRectDialog $varname 275 150
}

# actions

proc BpandaClose {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBasePandaRectClose $varname
}

proc BpandaApply {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBasePandaRectApply $varname
}

proc BpandaGenerate {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBaseAnnulusGenerateBox $varname
    MarkerBasePandaGenerateAngles $varname
}

# callbacks

proc BpandaCoordCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "BpandaCoordCB"
    }

    MarkerBasePandaRectCoordCB $varname
}

proc BpandaEditCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "BpandaEditCB"
    }

    MarkerBasePandaRectEditCB $varname
}

proc BpandaDistCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "BpandaDistCB"
    }

    MarkerBasePandaDistCB $varname
}
