#  Copyright (C) 1999-2010
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc EllipseDialog {varname} {
    upvar #0 $varname var
    global $varname

    # see if we already have a header window visible
    if [winfo exists $var(top)] {
	raise $var(top)
	return
    }

    # procs
    set var(which) ellipse
    set var(proc,apply) EllipseApply
    set var(proc,close) EllipseClose
    set var(proc,coordCB) EllipseCoordCB
    set var(proc,editCB) EllipseEditCB
    set var(proc,distCB) EllipseDistCB

    # base
    MarkerBaseRectDialog $varname 375 125 radius
}

# actions

proc EllipseClose {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBaseRectClose $varname
}

proc EllipseApply {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBaseRectApply $varname
}

# callbacks

proc EllipseCoordCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "EllipseCoordCB"
    }

    MarkerBaseRectCoordCB $varname
}

proc EllipseEditCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "EllipseEditCB"
    }

    MarkerBaseRectEditCB $varname
}

proc EllipseDistCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "EllipseDistCB"
    }

    MarkerBaseRectDistCB $varname
}

