#  Copyright (C) 1999-2010
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc EllipseAnnulusDialog {varname} {
    upvar #0 $varname var
    global $varname

    # see if we already have a header window visible
    if [winfo exists $var(top)] {
	raise $var(top)
	return
    }

    # procs
    set var(which) ellipseannulus
    set var(proc,apply) EllipseAnnulusApply
    set var(proc,close) EllipseAnnulusClose
    set var(proc,generate) EllipseAnnulusGenerate
    set var(proc,coordCB) EllipseAnnulusCoordCB
    set var(proc,editCB) EllipseAnnulusEditCB
    set var(proc,distCB) EllipseAnnulusDistCB

    # base
    MarkerBaseAnnulusRectDialog $varname 275 150 radius Major Minor
}

# actions

proc EllipseAnnulusClose {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBaseAnnulusRectClose $varname
}

proc EllipseAnnulusApply {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBaseAnnulusRectApply $varname
}

proc EllipseAnnulusGenerate {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBaseAnnulusGenerateEllipse $varname
}

# callbacks

proc EllipseAnnulusCoordCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "EllipseAnnulusCoordCB"
    }

    MarkerBaseAnnulusRectCoordCB $varname
}

proc EllipseAnnulusEditCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "EllipseAnnulusEditCB"
    }

    MarkerBaseAnnulusRectEditCB $varname
}

proc EllipseAnnulusDistCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "EllipseAnnulusDistCB"
    }

    MarkerBaseAnnulusRectDistCB $varname
}
