#  Copyright (C) 1999-2010
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc EpandaDialog {varname} {
    upvar #0 $varname var
    global $varname

    # see if we already have a header window visible
    if [winfo exists $var(top)] {
	raise $var(top)
	return
    }

    # procs
    set var(which) epanda
    set var(proc,apply) EpandaApply
    set var(proc,close) EpandaClose
    set var(proc,generate) EpandaGenerate
    set var(proc,coordCB) EpandaCoordCB
    set var(proc,editCB) EpandaEditCB
    set var(proc,distCB) EpandaDistCB

    # base panda rect dialog
    MarkerBasePandaRectDialog $varname 275 150
}

# actions

proc EpandaClose {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBasePandaRectClose $varname
}

proc EpandaApply {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBasePandaRectApply $varname
}

proc EpandaGenerate {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBaseAnnulusGenerateEllipse $varname
    MarkerBasePandaGenerateAngles $varname
}

# callbacks

proc EpandaCoordCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "EpandaCoordCB"
    }

    MarkerBasePandaRectCoordCB $varname
}

proc EpandaEditCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "EpandaEditCB"
    }

    MarkerBasePandaRectEditCB $varname
}

proc EpandaDistCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "EpandaDistCB"
    }

    MarkerBasePandaDistCB $varname
}
