#  Copyright (C) 1999-2010
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc AnalysisMenu {} {
    global ds9

    # WARNING: this is a variable length menu. 
    # Be sure to update ds9(menu,size,analysis)
    menu $ds9(mb).analysis
    $ds9(mb).analysis add command -label "[msgcat::mc {Pixel Table}]..." \
	-command PixelTableDialog 
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add command -label "[msgcat::mc {Mask Parameters}]..." \
	-command MaskDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton -label [msgcat::mc {Contours}] \
	-variable contour(view) -command ContourUpdate
    $ds9(mb).analysis add command -label "[msgcat::mc {Contour Parameters}]..."\
	-command ContourDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton -label [msgcat::mc {Coordinate Grid}] \
	-variable grid(view) -command GridUpdate
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Coordinate Grid Parameters}]..." \
	-command GridDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton -label [msgcat::mc {Smooth}] \
	-variable smooth(view) -command SmoothUpdate
    $ds9(mb).analysis add command -label "[msgcat::mc {Smooth Parameters}]..." \
	-command SmoothDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add command -label "[msgcat::mc {Name Resolution}]..." \
	-command NRESDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add cascade -label [msgcat::mc {Image Servers}] \
	-menu $ds9(mb).analysis.image
    $ds9(mb).analysis add cascade -label [msgcat::mc {Archives}] \
	-menu $ds9(mb).analysis.arch
    $ds9(mb).analysis add cascade -label [msgcat::mc {Catalogs}] \
	-menu $ds9(mb).analysis.cat
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Virtual Observatory}]..."\
	-command VODialog
    $ds9(mb).analysis add command -label "[msgcat::mc {Plot Tool}]..." \
	-command AnalysisPlotTool
    $ds9(mb).analysis add command -label "[msgcat::mc {Web Browser}]..." \
	-command {HV web Web {}}
    $ds9(mb).analysis add command -label "[msgcat::mc {Catalog Tool}]..." \
	-command CATOther
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton \
	-label [msgcat::mc {Analysis Command Log}] \
	-variable panalysis(log)
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Load Analysis Commands}]..." \
	-command OpenAnalysisMenu
    $ds9(mb).analysis add command \
	-label [msgcat::mc {Clear Analysis Commands}] \
	-command ClearAnalysisMenu

    menu $ds9(mb).analysis.image
    $ds9(mb).analysis.image add command \
	-label {SAO-DSS} -command SAODialog
    $ds9(mb).analysis.image add command \
	-label {ESO-DSS I/II} -command ESODialog
    $ds9(mb).analysis.image add command \
	-label {STSCI-DSS I/II} -command STSCIDialog
    $ds9(mb).analysis.image add command \
	-label {IPAC-2MASS} -command 2MASSDialog
    $ds9(mb).analysis.image add command \
	-label {NRAO-VLA FIRST} -command FIRSTDialog
    $ds9(mb).analysis.image add command \
	-label {NRAO-NVSS} -command NVSSDialog
    $ds9(mb).analysis.image add command \
	-label {HEASARC-SkyView} -command SkyViewDialog

    menu $ds9(mb).analysis.cat
    $ds9(mb).analysis.cat add command \
	-label [msgcat::mc {Search for Catalogs}] \
	-command "CATCDSSrchDialog catcdssrch1"
    $ds9(mb).analysis.cat add command -label [msgcat::mc {Clear All}] \
	-command CATClearCurrentFrame
    $ds9(mb).analysis.cat add separator
    CATCatalogMenu

    # Analysis Archive Menu
    menu $ds9(mb).analysis.arch
    $ds9(mb).analysis.arch add command -label {NVO DataScope} \
	-command HVArchDataScope
    $ds9(mb).analysis.arch add command -label {NVO Image Mosaic Service} \
	-command HVArchMontage
    $ds9(mb).analysis.arch add separator
    $ds9(mb).analysis.arch add cascade -label {Chandra} \
	-menu $ds9(mb).analysis.arch.chandra
    $ds9(mb).analysis.arch add command -label {ROSAT All-Sky (MPE/MPG)} \
	-command HVArchRosat
    $ds9(mb).analysis.arch add command -label {SkyView (NASA/HEASARC)} \
	-command HVArchSkyView
    $ds9(mb).analysis.arch add command -label {W3Browse (NASA/HEASARC)} \
	-command HVArchW3Browse
    $ds9(mb).analysis.arch add separator
    $ds9(mb).analysis.arch add command -label {NVSS (NRAO)} \
	-command HVArchNVSS
    $ds9(mb).analysis.arch add command -label {4MASS (NRAO)} \
	-command HVArch4MASS
    $ds9(mb).analysis.arch add command -label {SIRTF FLS/VLA (NRAO)} \
	-command HVArchSIRTF
    $ds9(mb).analysis.arch add command -label {VLA First (NRAO)} \
	-command HVArchFirst
    $ds9(mb).analysis.arch add separator
    $ds9(mb).analysis.arch add command -label {NED (NASA/IPAC)} \
	-command HVArchNED
    $ds9(mb).analysis.arch add cascade -label {SIMBAD (CDS)} \
	-menu $ds9(mb).analysis.arch.simbad
    $ds9(mb).analysis.arch add cascade -label {ADS (SAO)} \
	-menu $ds9(mb).analysis.arch.ads
    $ds9(mb).analysis.arch add separator
    $ds9(mb).analysis.arch add command -label {SAO TDC (SAO)} \
	-command HVArchSAOTDC

    menu $ds9(mb).analysis.arch.chandra
    $ds9(mb).analysis.arch.chandra add command \
	-label {Chaser (NASA/SAO)} -command HVArchChandraChaser
    $ds9(mb).analysis.arch.chandra add command \
	-label {Fast Image (NASA/SAO)} -command HVArchChandraPop
    $ds9(mb).analysis.arch.chandra add command \
	-label {Public FTP (SAO)} -command HVArchChandraFTP

    menu $ds9(mb).analysis.arch.simbad
    $ds9(mb).analysis.arch.simbad add command -label {SAO} \
	-command HVArchSIMBADSAO
    $ds9(mb).analysis.arch.simbad add command -label {CDS} \
	-command HVArchSIMBADCDS

    menu $ds9(mb).analysis.arch.ads
    $ds9(mb).analysis.arch.ads add command -label {SAO} \
	-command HVArchADSSAO
    $ds9(mb).analysis.arch.ads add command -label {CDS} \
	-command HVArchADSCDS
}

proc UpdateAnalysisMenuStatic {} {
    global ds9

    global debug
    if {$debug(tcl,update)} {
	puts stderr "UpdateAnalysisMenuStatic"
    }

    if {$ds9(active,num) > 0} {
	$ds9(mb) entryconfig [msgcat::mc {Analysis}] -state normal
    } else {
	$ds9(mb) entryconfig [msgcat::mc {Analysis}] -state disabled
    }
}

proc UpdateAnalysisMenu {} {
    global ds9
    global current
    global ianalysis

    global debug
    if {$debug(tcl,update)} {
	puts stderr "UpdateAnalysisMenu"
    }

    if {$current(frame) != {}} {
	for {set ii 0} {$ii<$ianalysis(menu,count)} {incr ii} {

	    if {[$current(frame) has fits]} {
		set fn [$current(frame) get fits file name 1]
	    } else {
		set fn {none}
	    }

	    # disable by default
	    $ianalysis(menu,$ii,parent) entryconfig $ianalysis(menu,$ii,item) \
		-state disabled

	    foreach tt $ianalysis(menu,$ii,template) {
		if {[regexp ".$tt" $fn]} {
		    $ianalysis(menu,$ii,parent) entryconfig \
			$ianalysis(menu,$ii,item) -state normal
		    break
		}
	    }
	}
    }
}

proc PrefsDialogAnalysis {} {
    global dprefs

    set w $dprefs(tab)

    $dprefs(list) insert end [msgcat::mc {Analysis}]
    lappend dprefs(tabs) [frame $w.analysis]

    frame $w.analysis.general -relief ridge -bd 1
    frame $w.analysis.contour -relief ridge -bd 1
    frame $w.analysis.smooth -relief ridge -bd 1
    frame $w.analysis.namesvr -relief ridge -bd 1
    frame $w.analysis.cat -relief ridge -bd 1
    pack $w.analysis.general $w.analysis.contour \
	$w.analysis.smooth $w.analysis.namesvr $w.analysis.cat \
	-side top -fill both -expand true

    # General
    set f $w.analysis.general.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Preload Analysis File}]
    entry $f.pre -textvariable panalysis(user) -width 60
    button $f.browse -text [msgcat::mc {Browse}] \
	-command "AnalysisPrefOpen panalysis(user)"
    entry $f.pre2 -textvariable panalysis(user2) -width 60
    button $f.browse2 -text [msgcat::mc {Browse}] \
	-command "AnalysisPrefOpen panalysis(user2)"
    entry $f.pre3 -textvariable panalysis(user3) -width 60
    button $f.browse3 -text [msgcat::mc {Browse}] \
	-command "AnalysisPrefOpen panalysis(user3)"
    entry $f.pre4 -textvariable panalysis(user4) -width 60
    button $f.browse4 -text [msgcat::mc {Browse}] \
	-command "AnalysisPrefOpen panalysis(user4)"
    checkbutton $f.log -text [msgcat::mc {Analysis Command Log}] \
	-variable panalysis(log)

    grid $f.title -padx 4 -sticky w
    grid $f.pre $f.browse -padx 4 -sticky w
    grid $f.pre2 $f.browse2 -padx 4 -sticky w
    grid $f.pre3 $f.browse3 -padx 4 -sticky w
    grid $f.pre4 $f.browse4 -padx 4 -sticky w
    grid $f.log -padx 4 -sticky w

    # Contour
    set f $w.analysis.contour.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Contours}]
    label $f.mtitle -text [msgcat::mc {Method}]
    menubutton $f.method -relief raised \
	-textvariable pcontour(method) -menu $f.method.menu

    global pcontour
    label $f.ctitle -text [msgcat::mc {Color}]
    ColorMenuButton $f.color pcontour color {}

    label $f.wtitle -text [msgcat::mc {Width}]
    menubutton $f.width -relief raised \
	-textvariable pcontour(width) -menu $f.width.menu
    WidthDashMenu $f.width.menu pcontour width dash {} {}

    grid $f.title -padx 4 -sticky w
    grid $f.mtitle $f.method $f.ctitle $f.color $f.wtitle $f.width \
	-padx 4 -sticky w

    set m $f.method.menu 
    menu $m
    $m add radiobutton -label [msgcat::mc {Block}] \
	-variable pcontour(method) -value block
    $m add radiobutton -label [msgcat::mc {Smooth}] \
	-variable pcontour(method) -value smooth

    # Smooth
    set f $w.analysis.smooth.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Smooth Function}]
    menubutton $f.function -relief raised \
	-textvariable psmooth(function) -menu $f.function.menu

    menu $f.function.menu
    $f.function.menu add radiobutton -label [msgcat::mc {Boxcar}] \
	-variable psmooth(function) -value boxcar
    $f.function.menu add radiobutton -label [msgcat::mc {Tophat}] \
	-variable psmooth(function) -value tophat
    $f.function.menu add radiobutton -label [msgcat::mc {Gaussian}] \
	-variable psmooth(function) -value gaussian

    grid $f.title $f.function -padx 4 -sticky w

    # Name Server
    set f $w.analysis.namesvr.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Name Server}]
    menubutton $f.svr -relief raised \
	-textvariable pnres(server) -menu $f.svr.menu

    menu $f.svr.menu
    NSVRServerMenuItems $f.svr.menu

    grid $f.title $f.svr -padx 4 -sticky w

    # Catalog
    set f $w.analysis.cat.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Catalogs}]
    label $f.stitle -text [msgcat::mc {Server}]
    menubutton $f.svr -relief raised \
	-textvariable pcat(server) -menu $f.svr.menu
    label $f.shtitle -text [msgcat::mc {Shape}]
    menubutton $f.shape -relief raised \
	-textvariable pcat(sym,shape) -menu $f.shape.menu
    checkbutton $f.vot -variable pcat(vot) \
	-text [msgcat::mc {Download VOTABLE format if available}]
    label $f.loctitle -text [msgcat::mc {IAU Location Code}]
    entry $f.loc -textvariable pcat(loc) -width 7

    global pcat
    label $f.ctitle -text [msgcat::mc {Color}]
    ColorMenuButton $f.color pcat sym,color {}

    label $f.ftitle -text [msgcat::mc {Font}]
    FontMenuButton $f.font pcat sym,font sym,font,size \
	sym,font,weight, sym,font,slant {}

    menu $f.svr.menu
    $f.svr.menu add radiobutton -label {CDS} \
	-variable pcat(server) -value cds
    $f.svr.menu add radiobutton -label {SAO} \
	-variable pcat(server) -value sao
    $f.svr.menu add radiobutton -label {CADC} \
	-variable pcat(server) -value cadc
    $f.svr.menu add radiobutton -label {ADAC} \
	-variable pcat(server) -value adac
    $f.svr.menu add radiobutton -label {IUCAA} \
	-variable pcat(server) -value iucaa
    $f.svr.menu add radiobutton -label {BEJING} \
	-variable pcat(server) -value bejing
    $f.svr.menu add radiobutton -label {CAMBRIDGE UK} \
	-variable pcat(server) -value cambridge
    $f.svr.menu add radiobutton -label {UKIRT HAWAII} \
	-variable pcat(server) -value ukirt

    menu $f.shape.menu
    $f.shape.menu add radiobutton -label [msgcat::mc {Circle Point}] \
	-variable pcat(sym,shape) -value {circle point}
    $f.shape.menu add radiobutton -label [msgcat::mc {Box Point}] \
	-variable pcat(sym,shape) -value {box point}
    $f.shape.menu add radiobutton -label [msgcat::mc {Diamond Point}] \
	-variable pcat(sym,shape) -value {diamond point}
    $f.shape.menu add radiobutton -label [msgcat::mc {Cross Point}] \
	-variable pcat(sym,shape) -value {cross point}
    $f.shape.menu add radiobutton -label [msgcat::mc {X Point}] \
	-variable pcat(sym,shape) -value {x point}
    $f.shape.menu add radiobutton -label [msgcat::mc {Arrow Point}] \
	-variable pcat(sym,shape) -value {arrow point}
    $f.shape.menu add radiobutton -label [msgcat::mc {BoxCircle Point}] \
	-variable pcat(sym,shape) -value {boxcircle point}
    $f.shape.menu add separator
    $f.shape.menu add radiobutton -label [msgcat::mc {Circle}] \
	-variable pcat(sym,shape) -value circle
    $f.shape.menu add radiobutton -label [msgcat::mc {Ellipse}] \
	-variable pcat(sym,shape) -value ellipse
    $f.shape.menu add radiobutton -label [msgcat::mc {Box}] \
	-variable pcat(sym,shape) -value box
    $f.shape.menu add radiobutton -label [msgcat::mc {Text}] \
	-variable pcat(sym,shape) -value text

    grid $f.title -padx 4 -sticky w
    grid $f.stitle $f.svr -padx 4 -sticky w
    grid $f.shtitle $f.shape  -padx 4 -sticky w
    grid $f.ctitle $f.color  -padx 4 -sticky w
    grid $f.ftitle $f.font -padx 4 -sticky w
    grid $f.loctitle - $f.loc - - - -padx 4 -sticky w
    grid $f.vot - - - - - -padx 4 -sticky w
}

