#  Copyright (C) 1999-2010
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

# Menus

proc RegionMenu {} {
    global ds9
    global marker

    menu $ds9(mb).region
    $ds9(mb).region add command -label "[msgcat::mc {Get Information}]..." \
	-command MarkerInfo
    $ds9(mb).region add separator
    $ds9(mb).region add cascade -label [msgcat::mc {Shape}] \
	-menu $ds9(mb).region.shape
    $ds9(mb).region add cascade -label [msgcat::mc {Composite Region}] \
	-menu $ds9(mb).region.composite
    $ds9(mb).region add cascade -label [msgcat::mc {Instrument FOV}] \
	-menu $ds9(mb).region.fov
    $ds9(mb).region add cascade -label [msgcat::mc {Template}] \
	-menu $ds9(mb).region.template
    $ds9(mb).region add separator
    $ds9(mb).region add cascade -label [msgcat::mc {Color}] \
	-menu $ds9(mb).region.color
    $ds9(mb).region add cascade -label [msgcat::mc {Width}] \
	-menu $ds9(mb).region.width
    $ds9(mb).region add cascade -label [msgcat::mc {Properties}] \
	-menu $ds9(mb).region.properties
    $ds9(mb).region add cascade -label [msgcat::mc {Font}] \
	-menu $ds9(mb).region.font
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {Centroid}] \
	-command MarkerCentroid
    $ds9(mb).region add command -label [msgcat::mc {Move to Front}] \
	-command MarkerFront
    $ds9(mb).region add command -label [msgcat::mc {Move to Back}] \
	-command MarkerBack
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {Select All}] \
	-command MarkerSelectAll -accelerator "${ds9(ctrl)}A"
    $ds9(mb).region add command -label [msgcat::mc {Select None}] \
	-command MarkerUnselectAll
    $ds9(mb).region add command -label [msgcat::mc {Invert Selection}] \
	-command MarkerSelectInvert
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {Delete Selected Regions}] \
	-command MarkerDeleteSelect
    $ds9(mb).region add command -label [msgcat::mc {Delete All Regions}] \
	-command MarkerDeleteAllMenu
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {New Group}] \
	-command GroupCreate
    $ds9(mb).region add command -label "[msgcat::mc {Groups}]..." \
	-command GroupDialog
    $ds9(mb).region add separator
    $ds9(mb).region add command -label "[msgcat::mc {List Regions}]..." \
	-command MarkerList
    $ds9(mb).region add command -label "[msgcat::mc {Load Regions}]..." \
	-command MarkerLoad
    $ds9(mb).region add command -label "[msgcat::mc {Save Regions}]..." \
	-command MarkerSave
    $ds9(mb).region add separator
    $ds9(mb).region add cascade -label [msgcat::mc {Region Parameters}] \
	-menu $ds9(mb).region.params

    menu $ds9(mb).region.shape
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Circle}] \
	-variable marker(shape) -value circle
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Ellipse}] \
	-variable marker(shape) -value ellipse
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Box}] \
	-variable marker(shape) -value box
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Polygon}] \
	-variable marker(shape) -value polygon
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Line}] \
	-variable marker(shape) -value line
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Vector}] \
	-variable marker(shape) -value vector
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Text}] \
	-variable marker(shape) -value text
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Ruler}] \
	-variable marker(shape) -value ruler
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Compass}] \
	-variable marker(shape) -value compass
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Projection}] \
	-variable marker(shape) -value projection
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Annulus}] \
	-variable marker(shape) -value annulus
    $ds9(mb).region.shape add radiobutton \
	-label [msgcat::mc {Elliptical Annulus}] \
	-variable marker(shape) -value ellipseannulus
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Box Annulus}] \
	-variable marker(shape) -value boxannulus
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Panda}] \
	-variable marker(shape) -value panda
    $ds9(mb).region.shape add radiobutton \
	-label [msgcat::mc {Elliptical Panda}]\
	-variable marker(shape) -value epanda
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Box Panda}] \
	-variable marker(shape) -value bpanda
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Circle Point}] \
	-variable marker(shape) -value {circle point} 
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Box Point}] \
	-variable marker(shape) -value {box point}
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Diamond Point}] \
	-variable marker(shape) -value {diamond point}
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Cross Point}] \
	-variable marker(shape) -value {cross point}
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {X Point}] \
	-variable marker(shape) -value {x point}
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Arrow Point}] \
	-variable marker(shape) -value {arrow point} 
    $ds9(mb).region.shape add radiobutton \
	-label [msgcat::mc {BoxCircle Point}] \
	-variable marker(shape) -value {boxcircle point}
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Circle3d}] \
	-variable marker(shape) -value circle3d

    menu $ds9(mb).region.composite
    $ds9(mb).region.composite add command -label [msgcat::mc {Create}] \
	-command CompositeCreate
    $ds9(mb).region.composite add command -label [msgcat::mc {Dissolve}] \
	-command CompositeDelete

    CreateFOVMenu

    menu $ds9(mb).region.template
    $ds9(mb).region.template add command -label "[msgcat::mc {Load}]..." \
	-command OpenTemplateMarker
    $ds9(mb).region.template add command -label "[msgcat::mc {Save}]..." \
	-command SaveAsTemplateMarker

    ColorMenu $ds9(mb).region.color marker color MarkerColor
    WidthDashMenu $ds9(mb).region.width marker width dash \
	MarkerWidth [list MarkerProp dash]

    menu $ds9(mb).region.properties
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Fixed in Size}] \
	-variable marker(fixed) -command {MarkerProp fixed}
    $ds9(mb).region.properties add separator
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Can Edit}] \
	-variable marker(edit) -command {MarkerProp edit}
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Can Move}] \
	-variable marker(move) -command {MarkerProp move}
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Can Rotate}] \
	-variable marker(rotate) -command {MarkerProp rotate}
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Can Delete}] \
	-variable marker(delete) -command {MarkerProp delete}
    $ds9(mb).region.properties add separator
    $ds9(mb).region.properties add radiobutton \
	-label [msgcat::mc {Include}] \
	-variable marker(include) -value 1 -command {MarkerProp include}
    $ds9(mb).region.properties add radiobutton \
	-label [msgcat::mc {Exclude}] \
	-variable marker(include) -value 0 -command {MarkerProp include}
    $ds9(mb).region.properties add separator
    $ds9(mb).region.properties add radiobutton \
	-label [msgcat::mc {Source}] \
	-variable marker(source) -value 1 -command {MarkerProp source}
    $ds9(mb).region.properties add radiobutton \
	-label [msgcat::mc {Background}] \
	-variable marker(source) -value 0 -command {MarkerProp source}

    FontMenu $ds9(mb).region.font marker font font,size font,weight \
	font,slant MarkerFont

    menu $ds9(mb).region.params
    $ds9(mb).region.params add checkbutton \
	-label [msgcat::mc {Show Regions}] \
	-variable marker(show) -command MarkerShow
    $ds9(mb).region.params add checkbutton \
	-label [msgcat::mc {Show Regions Text}] \
	-variable marker(show,text) -command MarkerShowText
    $ds9(mb).region.params add separator
    $ds9(mb).region.params add checkbutton \
	-label [msgcat::mc {Auto Centroid}] \
	-variable marker(centroid,auto) -command MarkerCentroidAuto
    $ds9(mb).region.params add command \
	-label "[msgcat::mc {Centroid Parameters}]..." \
	-command CentroidDialog

    # Bindings
    bind $ds9(top) <<SelectAll>> MarkerSelectAll
}

proc PrefsDialogRegion {} {
    global dprefs

    set w $dprefs(tab)

    $dprefs(list) insert end [msgcat::mc {Region}]
    lappend dprefs(tabs) [frame $w.region]

    frame $w.region.menu -relief ridge -bd 1
    frame $w.region.general -relief ridge -bd 1
    frame $w.region.format -relief ridge -bd 1
    frame $w.region.centroid -relief ridge -bd 1
    frame $w.region.circle -relief ridge -bd 1
    frame $w.region.ellipse -relief ridge -bd 1
    frame $w.region.box -relief ridge -bd 1
    frame $w.region.point -relief ridge -bd 1
    frame $w.region.projection -relief ridge -bd 1
    frame $w.region.circle3d -relief ridge -bd 1
    pack $w.region.menu $w.region.general $w.region.format \
	$w.region.centroid $w.region.circle $w.region.ellipse \
	$w.region.box $w.region.point $w.region.projection \
	$w.region.circle3d \
	-side top -fill both -expand true

    # Default Menu
    set f $w.region.menu.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Default}]
    menubutton $f.menu -relief raised -text [msgcat::mc {Menu}] \
	-menu $f.menu.menu
    PrefsDialogButtonbarRegion $f.buttonbar

    grid $f.title $f.menu $f.buttonbar -padx 4 -sticky w

    set m $f.menu.menu
    menu $m
    $m add cascade -label [msgcat::mc {Shape}] -menu $m.shape
    $m add separator
    $m add cascade -label [msgcat::mc {Color}] -menu $m.color
    $m add cascade -label [msgcat::mc {Width}] -menu $m.width
    $m add cascade -label [msgcat::mc {Properties}] -menu $m.properties
    $m add cascade -label [msgcat::mc {Font}] -menu $m.font
    $m add separator
    $m add cascade -label [msgcat::mc {Region Parameters}] -menu $m.params

    menu $m.shape
    $m.shape add radiobutton -label [msgcat::mc {Circle}] \
	-variable pmarker(shape) -value circle
    $m.shape add radiobutton -label [msgcat::mc {Ellipse}] \
	-variable pmarker(shape) -value ellipse
    $m.shape add radiobutton -label [msgcat::mc {Box}] \
	-variable pmarker(shape) -value box
    $m.shape add radiobutton -label [msgcat::mc {Polygon}] \
	-variable pmarker(shape) -value polygon
    $m.shape add radiobutton -label [msgcat::mc {Line}] \
	-variable pmarker(shape) -value line
    $m.shape add radiobutton -label [msgcat::mc {Vector}] \
	-variable pmarker(shape) -value vector
    $m.shape add radiobutton -label [msgcat::mc {Text}] \
	-variable pmarker(shape) -value text
    $m.shape add separator
    $m.shape add radiobutton -label [msgcat::mc {Ruler}] \
	-variable pmarker(shape) -value ruler
    $m.shape add radiobutton -label [msgcat::mc {Compass}] \
	-variable pmarker(shape) -value compass
    $m.shape add radiobutton -label [msgcat::mc {Projection}] \
	-variable pmarker(shape) -value projection
    $m.shape add separator
    $m.shape add radiobutton -label [msgcat::mc {Annulus}] \
	-variable pmarker(shape) -value annulus
    $m.shape add radiobutton -label [msgcat::mc {Elliptical Annulus}] \
	-variable pmarker(shape) -value ellipseannulus
    $m.shape add radiobutton -label [msgcat::mc {Box Annulus}] \
	-variable pmarker(shape) -value boxannulus
    $m.shape add radiobutton -label [msgcat::mc {Panda}] \
	-variable pmarker(shape) -value panda
    $m.shape add radiobutton -label [msgcat::mc {Elliptical Panda}] \
	-variable pmarker(shape) -value epanda
    $m.shape add radiobutton -label [msgcat::mc {Box Panda}] \
	-variable pmarker(shape) -value bpanda
    $m.shape add separator
    $m.shape add radiobutton -label [msgcat::mc {Circle Point}] \
	-variable pmarker(shape) -value {circle point}
    $m.shape add radiobutton -label [msgcat::mc {Box Point}] \
	-variable pmarker(shape) -value {box point} 
    $m.shape add radiobutton -label [msgcat::mc {Diamond Point}] \
	-variable pmarker(shape) -value {diamond point}
    $m.shape add radiobutton -label [msgcat::mc {Cross Point}] \
	-variable pmarker(shape) -value {cross point}
    $m.shape add radiobutton -label [msgcat::mc {X Point}] \
	-variable pmarker(shape) -value {x point}
    $m.shape add radiobutton -label [msgcat::mc {Arrow Point}] \
	-variable pmarker(shape) -value {arrow point}
    $m.shape add radiobutton -label [msgcat::mc {BoxCircle Point}] \
	-variable pmarker(shape) -value {boxcircle point}
    $m.shape add separator
    $m.shape add radiobutton -label [msgcat::mc {Circle3d}] \
	-variable pmarker(shape) -value circle3d

    ColorMenu $m.color pmarker color {}
    WidthDashMenu $m.width pmarker width dash {} {}

    menu $m.properties
    $m.properties add checkbutton -label [msgcat::mc {Fixed in Size}] \
	-variable pmarker(fixed)
    $m.properties add separator
    $m.properties add checkbutton -label [msgcat::mc {Can Edit}] \
	-variable pmarker(edit)
    $m.properties add checkbutton -label [msgcat::mc {Can Move}] \
	-variable pmarker(move)
    $m.properties add checkbutton -label [msgcat::mc {Can Rotate}] \
	-variable pmarker(rotate)
    $m.properties add checkbutton -label [msgcat::mc {Can Delete}] \
	-variable pmarker(delete)
    $m.properties add separator
    $m.properties add radiobutton -label [msgcat::mc {Include}] \
	-variable pmarker(include) -value 1
    $m.properties add radiobutton -label [msgcat::mc {Exclude}] \
	-variable pmarker(include) -value 0
    $m.properties add separator
    $m.properties add radiobutton -label [msgcat::mc {Source}] \
	-variable pmarker(source) -value 1
    $m.properties add radiobutton -label [msgcat::mc {Background}] \
	-variable pmarker(source) -value 0

    FontMenu $m.font pmarker font font,size font,weight font,slant {}

    menu $m.params
    $m.params add checkbutton -label [msgcat::mc {Show Regions}] \
	-variable pmarker(show)
    $m.params add checkbutton -label [msgcat::mc {Show Regions Text}] \
	-variable pmarker(show,text)
    $m.params add separator
    $m.params add checkbutton -label [msgcat::mc {Auto Centroid}] \
	-variable pmarker(centroid,auto)

    # Default Dialog
    set f $w.region.general.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Default Dialog}]
    menubutton $f.sys -relief raised \
	-text [msgcat::mc {Coordinate System}] -menu $f.sys.menu
    menubutton $f.dist -relief raised \
	-text [msgcat::mc {Distance System}] -menu $f.dist.menu

    grid $f.title -padx 4 -sticky w
    grid $f.sys $f.dist -padx 4 -sticky w

    CoordMenu $f.sys.menu pmarker dialog,system dialog,sky dialog,skyformat {}
    DistMenu $f.dist.menu pmarker dialog,dist,system dialog,dist,format {}

    # Default Format
    set f $w.region.format.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Default Format}]
    menubutton $f.format -relief raised \
	-textvariable pmarker(format) -menu $f.format.menu

    grid $f.title -padx 4 -sticky w
    grid $f.format -padx 4 -sticky w

    menu $f.format.menu
    $f.format.menu add radiobutton -label {DS9/Funtools} \
	-variable pmarker(format) -value ds9
    $f.format.menu add radiobutton -label {XML} \
	-variable pmarker(format) -value xml
    $f.format.menu add radiobutton -label {CIAO} \
	-variable pmarker(format) -value ciao
    $f.format.menu add radiobutton -label {SAOtng} \
	-variable pmarker(format) -value saotng
    $f.format.menu add radiobutton -label {SAOimage} \
	-variable pmarker(format) -value saoimage
    $f.format.menu add radiobutton -label {IRAF PROS} \
	-variable pmarker(format) -value pros
    $f.format.menu add radiobutton -label {X Y} \
	-variable pmarker(format) -value xy

    # Default Centroid
    set f $w.region.centroid.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Centroid}]
    label $f.ititle -text [msgcat::mc {Iteration}]
    entry $f.iteration -textvariable pmarker(centroid,iteration) -width 10
    label $f.rtitle -text [msgcat::mc {Radius}]
    entry $f.radius -textvariable pmarker(centroid,radius) -width 10
   
    grid $f.default -padx 4 -sticky w
    grid $f.ititle $f.iteration $f.rtitle $f.radius -padx 4 -sticky w

    # Default Circle
    set f $w.region.circle.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Circle}]
    label $f.title -text [msgcat::mc {Radius}]
    entry $f.radius -textvariable pmarker(circle,radius) -width 10
    label $f.unit -text [msgcat::mc {Image}]
   
    grid $f.default -padx 4 -sticky w
    grid $f.title $f.radius $f.unit -padx 4 -sticky w

    # Default Ellipse
    set f $w.region.ellipse.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Ellipse}]
    label $f.title -text "Radius 1"
    entry $f.radius1 -textvariable pmarker(ellipse,radius1) -width 10 
    label $f.unit -text [msgcat::mc {Image}]
    
    label $f.title2 -text "Radius 2"
    entry $f.radius2 -textvariable pmarker(ellipse,radius2) -width 10 
    label $f.unit2 -text [msgcat::mc {Image}]

    grid $f.default -padx 4 -sticky w
    grid $f.title $f.radius1 $f.unit -padx 4 -pady 1 -sticky w
    grid $f.title2 $f.radius2 $f.unit2 -padx 4 -pady 1 -sticky w
    
    # Default Box
    set f $w.region.box.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Box}]
    label $f.title -text "Size 1"
    entry $f.radius1 -textvariable pmarker(box,radius1) -width 10 
    label $f.unit -text [msgcat::mc {Image}]
    
    label $f.title2 -text "Size 2"
    entry $f.radius2 -textvariable pmarker(box,radius2) -width 10 
    label $f.unit2 -text [msgcat::mc {Image}]

    grid $f.default -padx 4 -sticky w
    grid $f.title $f.radius1 $f.unit -padx 4 -pady 1 -sticky w
    grid $f.title2 $f.radius2 $f.unit2 -padx 4 -pady 1 -sticky w

    # Default Point
    set f $w.region.point.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Point}]
    label $f.title -text [msgcat::mc {Size}]
    entry $f.size -textvariable pmarker(point,size) -width 10
    label $f.unit -text [msgcat::mc {Pixels}]
    
    grid $f.default -padx 4 -sticky w
    grid $f.title $f.size $f.unit -padx 4 -sticky w

    # Default Projection
    set f $w.region.projection.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Projection}]
    label $f.title -text [msgcat::mc {Thickness}]
    entry $f.thick -textvariable pmarker(projection,thick) -width 10
    label $f.unit -text [msgcat::mc {Image}]
    
    grid $f.default -padx 4 -sticky w
    grid $f.title $f.thick $f.unit -padx 4 -sticky w

    # Default Circle3d
    set f $w.region.circle3d.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Circle3d}]
    label $f.title -text [msgcat::mc {Radius}]
    entry $f.radius -textvariable pmarker(circle3d,radius) -width 10
    label $f.unit -text [msgcat::mc {Image}]
    
    grid $f.default -padx 4 -sticky w
    grid $f.title $f.radius $f.unit -padx 4 -sticky w
}

proc PrefsDialogAnnulus {} {
    global dprefs

    set w $dprefs(tab)

    $dprefs(list) insert end [msgcat::mc {Annulus}]
    lappend dprefs(tabs) [frame $w.annulus]

    frame $w.annulus.annulus -relief ridge -bd 1
    frame $w.annulus.ellipseannulus -relief ridge -bd 1
    frame $w.annulus.boxannulus -relief ridge -bd 1
    pack $w.annulus.annulus $w.annulus.ellipseannulus $w.annulus.boxannulus \
	-side top -fill both -expand true

    # Default Annulus
    set f $w.annulus.annulus.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Annulus}]
    label $f.innerTitle -text [msgcat::mc {Inner}]
    label $f.outerTitle -text [msgcat::mc {Outer}]
    label $f.radiusTitle -text [msgcat::mc {Radius}]
    entry $f.inner -textvariable pmarker(annulus,inner) -width 10
    entry $f.outer -textvariable pmarker(annulus,outer) -width 10
    label $f.unit -text [msgcat::mc {Image}]
    label $f.annuliTitle -text [msgcat::mc {Annuli}]
    entry $f.annuli -textvariable pmarker(annulus,annuli) -width 10
    
    grid $f.default -padx 4 -sticky w
    grid x $f.innerTitle $f.outerTitle -padx 4 -sticky w
    grid $f.radiusTitle $f.inner $f.outer $f.unit -padx 4 -sticky w
    grid $f.annuliTitle $f.annuli -padx 4 -sticky w

    # Default Ellipse Annulus
    set f $w.annulus.ellipseannulus.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Elliptical Annulus}]
    label $f.majorTitle -text [msgcat::mc {Major}]
    label $f.minorTitle -text [msgcat::mc {Minor}]

    label $f.innerTitle -text [msgcat::mc {Inner}]
    entry $f.radius1 -textvariable pmarker(ellipseannulus,radius1) -width 10 	
    entry $f.radius2 -textvariable pmarker(ellipseannulus,radius2) -width 10 
    label $f.unit -text [msgcat::mc {Image}]

    label $f.outerTitle -text [msgcat::mc {Outer}]
    entry $f.radius3 -textvariable pmarker(ellipseannulus,radius3) -width 10 

    label $f.annuliTitle -text [msgcat::mc {Annuli}]
    entry $f.annuli -textvariable pmarker(ellipseannulus,annuli) -width 10 
    
    grid $f.default -padx 4 -sticky w
    grid x $f.majorTitle $f.minorTitle -padx 4 -sticky w
    grid $f.innerTitle $f.radius1 $f.radius2 $f.unit \
	-padx 4 -sticky w
    grid $f.outerTitle $f.radius3 -padx 4 -sticky w
    grid $f.annuliTitle $f.annuli -padx 4 -sticky w

    # Default Box Annulus
    set f $w.annulus.boxannulus.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Box Annulus}]
    label $f.majorTitle -text [msgcat::mc {Width}]
    label $f.minorTitle -text [msgcat::mc {Height}]

    label $f.innerTitle -text [msgcat::mc {Inner}]
    entry $f.radius1 -textvariable pmarker(boxannulus,radius1) -width 10 	
    entry $f.radius2 -textvariable pmarker(boxannulus,radius2) -width 10 
    label $f.unit -text [msgcat::mc {Image}]

    label $f.outerTitle -text [msgcat::mc {Outer}]
    entry $f.radius3 -textvariable pmarker(boxannulus,radius3) -width 10 

    label $f.annuliTitle -text [msgcat::mc {Annuli}]
    entry $f.annuli -textvariable pmarker(boxannulus,annuli) -width 10 
    
    grid $f.default -padx 4 -sticky w
    grid x $f.majorTitle $f.minorTitle -padx 4 -sticky w
    grid $f.innerTitle $f.radius1 $f.radius2 $f.unit \
	-padx 4 -sticky w
    grid $f.outerTitle $f.radius3 -padx 4 -sticky w
    grid $f.annuliTitle $f.annuli -padx 4 -sticky w

}

proc PrefsDialogPanda {} {
    global dprefs

    set w $dprefs(tab)

    $dprefs(list) insert end [msgcat::mc {Panda}]
    lappend dprefs(tabs) [frame $w.panda]

    frame $w.panda.panda -relief ridge -bd 1
    frame $w.panda.epanda -relief ridge -bd 1
    frame $w.panda.bpanda -relief ridge -bd 1
    pack $w.panda.panda $w.panda.epanda $w.panda.bpanda \
	-side top -fill both -expand true

    # Default Panda
    set f $w.panda.panda.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Panda}]
    label $f.innerTitle -text [msgcat::mc {Inner}]
    label $f.outerTitle -text [msgcat::mc {Outer}]
    label $f.radiusTitle -text [msgcat::mc {Radius}]
    entry $f.inner -textvariable pmarker(panda,inner) -width 10
    entry $f.outer -textvariable pmarker(panda,outer) -width 10
    label $f.unit -text [msgcat::mc {Image}]
    label $f.annuliTitle -text [msgcat::mc {Annuli}]
    entry $f.annuli -textvariable pmarker(panda,annuli) -width 10
    
    grid $f.default -padx 4 -sticky w
    grid x $f.innerTitle $f.outerTitle -padx 4 -sticky w
    grid $f.radiusTitle $f.inner $f.outer $f.unit -padx 4 -sticky w
    grid $f.annuliTitle $f.annuli -padx 4 -sticky w

    label $f.ang1Title -text [msgcat::mc {Start}]
    label $f.ang2Title -text [msgcat::mc {Stop}]
    label $f.angTitle -text [msgcat::mc {Angles}]
    entry $f.ang1 -textvariable pmarker(panda,ang1) -width 10
    entry $f.ang2 -textvariable pmarker(panda,ang2) -width 10
    label $f.angunit -text [msgcat::mc {Degrees}]
    label $f.angnumTitle -text [msgcat::mc {Number}]
    entry $f.angnum -textvariable pmarker(panda,angnum) -width 10
    
    grid x $f.ang1Title $f.ang2Title -padx 4 -sticky w
    grid $f.angTitle $f.ang1 $f.ang2 $f.angunit -padx 4 -sticky w
    grid $f.angnumTitle $f.angnum -padx 4 -sticky w

    # Default Elliptical Panda
    set f $w.panda.epanda.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Elliptical Panda}]

    label $f.majorTitle -text [msgcat::mc {Major}]
    label $f.minorTitle -text [msgcat::mc {Minor}]

    label $f.innerTitle -text [msgcat::mc {Inner}]
    entry $f.radius1 -textvariable pmarker(epanda,radius1) -width 10 	
    entry $f.radius2 -textvariable pmarker(epanda,radius2) -width 10 
    label $f.unit -text [msgcat::mc {Image}]

    label $f.outerTitle -text [msgcat::mc {Outer}]
    entry $f.radius3 -textvariable pmarker(epanda,radius3) -width 10 

    label $f.annuliTitle -text [msgcat::mc {Annuli}]
    entry $f.annuli -textvariable pmarker(epanda,annuli) -width 10
    
    grid $f.default -padx 4 -sticky w
    grid x $f.majorTitle $f.minorTitle -padx 4 -sticky w
    grid $f.innerTitle $f.radius1 $f.radius2 $f.unit -padx 4 -sticky w
    grid $f.outerTitle $f.radius3 -padx 4 -sticky w
    grid $f.annuliTitle $f.annuli -padx 4 -sticky w

    label $f.ang1Title -text [msgcat::mc {Start}]
    label $f.ang2Title -text [msgcat::mc {Stop}]
    label $f.angTitle -text [msgcat::mc {Angles}]
    entry $f.ang1 -textvariable pmarker(epanda,ang1) -width 10
    entry $f.ang2 -textvariable pmarker(epanda,ang2) -width 10
    label $f.angunit -text [msgcat::mc {Degrees}]
    label $f.angnumTitle -text [msgcat::mc {Number}]
    entry $f.angnum -textvariable pmarker(epanda,angnum) -width 10
    
    grid x $f.ang1Title $f.ang2Title -padx 4 -sticky w
    grid $f.angTitle $f.ang1 $f.ang2 $f.angunit -padx 4 -sticky w
    grid $f.angnumTitle $f.angnum -padx 4 -sticky w

    # Default Box Panda
    set f $w.panda.bpanda.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.default -text [msgcat::mc {Box Panda}]

    label $f.majorTitle -text [msgcat::mc {Major}]
    label $f.minorTitle -text [msgcat::mc {Minor}]

    label $f.innerTitle -text [msgcat::mc {Inner}]
    entry $f.radius1 -textvariable pmarker(bpanda,radius1) -width 10 	
    entry $f.radius2 -textvariable pmarker(bpanda,radius2) -width 10 
    label $f.unit -text [msgcat::mc {Image}]

    label $f.outerTitle -text [msgcat::mc {Outer}]
    entry $f.radius3 -textvariable pmarker(bpanda,radius3) -width 10 

    label $f.annuliTitle -text [msgcat::mc {Annuli}]
    entry $f.annuli -textvariable pmarker(bpanda,annuli) -width 10
    
    grid $f.default -padx 4 -sticky w
    grid x $f.majorTitle $f.minorTitle -padx 4 -sticky w
    grid $f.innerTitle $f.radius1 $f.radius2 $f.unit -padx 4 -sticky w
    grid $f.outerTitle $f.radius3 -padx 4 -sticky w
    grid $f.annuliTitle $f.annuli -padx 4 -sticky w

    label $f.ang1Title -text [msgcat::mc {Start}]
    label $f.ang2Title -text [msgcat::mc {Stop}]
    label $f.angTitle -text [msgcat::mc {Angles}]
    entry $f.ang1 -textvariable pmarker(bpanda,ang1) -width 10
    entry $f.ang2 -textvariable pmarker(bpanda,ang2) -width 10
    label $f.angunit -text [msgcat::mc {Degrees}]
    label $f.angnumTitle -text [msgcat::mc {Number}]
    entry $f.angnum -textvariable pmarker(bpanda,angnum) -width 10
    
    grid x $f.ang1Title $f.ang2Title -padx 4 -sticky w
    grid $f.angTitle $f.ang1 $f.ang2 $f.angunit -padx 4 -sticky w
    grid $f.angnumTitle $f.angnum -padx 4 -sticky w
}

# Buttons

proc ButtonsRegionDef {} {
    global pbuttons

    array set pbuttons {
	region,info 1
	region,circle 0
	region,ellipse 0
	region,box 0
	region,polygon 0
	region,line 0
	region,vector 0
	region,text 0
	region,point 0
	region,ruler 0
	region,compass 0
	region,projection 0
	region,annulus 0
	region,ellipseannulus 0
	region,boxannulus 0
	region,panda 0
	region,epanda 0
	region,bpanda 0
	region,circle3d 0
	region,create 0
	region,dissolve 0
	region,loadtemplate 0
	region,savetemplate 0
	region,centroid 0
	region,front 1
	region,back 1
	region,all 1
	region,none 1
	region,invert 0
	region,delete 1
	region,deleteall 0
	region,newgroup 0
	region,group 0
	region,list 1
	region,load 1
	region,save 1
	region,show 0
	region,showtext 0
	region,autocentroid 0
    }
}

proc CreateButtonsRegion {} {
    global buttons
    global ds9

    frame $ds9(buttons).region

    ButtonButton $ds9(buttons).region.info \
	[string tolower [msgcat::mc {Information}]] MarkerInfo

    RadioButton $ds9(buttons).region.circle \
	[string tolower [msgcat::mc {Circle}]] \
	marker(shape) circle {}
    RadioButton $ds9(buttons).region.ellipse \
	[string tolower [msgcat::mc {Ellipse}]] \
	marker(shape) ellipse {}
    RadioButton $ds9(buttons).region.box \
	[string tolower [msgcat::mc {Box}]] \
	marker(shape) box {}
    RadioButton $ds9(buttons).region.polygon \
	[string tolower [msgcat::mc {Polygon}]] \
	marker(shape) polygon {}
    RadioButton $ds9(buttons).region.line \
	[string tolower [msgcat::mc {Line}]] \
	marker(shape) line {}
    RadioButton $ds9(buttons).region.vector \
	[string tolower [msgcat::mc {Vector}]] \
	marker(shape) vector {}
    RadioButton $ds9(buttons).region.text \
	[string tolower [msgcat::mc {Text}]] \
	marker(shape) text {}
    RadioButton $ds9(buttons).region.point \
	[string tolower [msgcat::mc {Point}]] \
	marker(shape) {circle point} {}
    RadioButton $ds9(buttons).region.ruler \
	[string tolower [msgcat::mc {Ruler}]] \
	marker(shape) ruler {}
    RadioButton $ds9(buttons).region.compass \
	[string tolower [msgcat::mc {Compass}]] \
	marker(shape) compass {}
    RadioButton $ds9(buttons).region.projection \
	[string tolower [msgcat::mc {Projection}]] \
	marker(shape) projection {}
    RadioButton $ds9(buttons).region.annulus \
	[string tolower [msgcat::mc {Annulus}]] \
	marker(shape) annulus {}
    RadioButton $ds9(buttons).region.ellipseannulus \
	[string tolower [msgcat::mc {Elliptical Annulus}]] \
	marker(shape) ellipseannulus {}
    RadioButton $ds9(buttons).region.boxannulus \
	[string tolower [msgcat::mc {Box Annulus}]] \
	marker(shape) boxannulus {}
    RadioButton $ds9(buttons).region.panda \
	[string tolower [msgcat::mc {Panda}]] \
	marker(shape) panda {}
    RadioButton $ds9(buttons).region.epanda \
	[string tolower [msgcat::mc {Ellipse Panda}]] \
	marker(shape) epanda {}
    RadioButton $ds9(buttons).region.bpanda \
	[string tolower [msgcat::mc {Box Panda}]] \
	marker(shape) bpanda {}
    RadioButton $ds9(buttons).region.circle3d \
	[string tolower [msgcat::mc {Circle3d}]] \
	marker(shape) circle3d {}

    ButtonButton $ds9(buttons).region.create \
	[string tolower [msgcat::mc {Composite}]] CompositeCreate
    ButtonButton $ds9(buttons).region.dissolve \
	[string tolower [msgcat::mc {Dissolve}]] CompositeDelete

    ButtonButton $ds9(buttons).region.loadtemplate \
	[string tolower [msgcat::mc {Load Template}]] OpenTemplateMarker
    ButtonButton $ds9(buttons).region.savetemplate \
	[string tolower [msgcat::mc {Save Template}]] SaveAsTemplateMarker

    ButtonButton $ds9(buttons).region.centroid \
	[string tolower [msgcat::mc {Centroid}]] MarkerCentroid
    ButtonButton $ds9(buttons).region.front \
	[string tolower [msgcat::mc {Front}]] MarkerFront
    ButtonButton $ds9(buttons).region.back \
	[string tolower [msgcat::mc {Back}]] MarkerBack

    ButtonButton $ds9(buttons).region.all \
	[string tolower [msgcat::mc {All}]] MarkerSelectAll
    ButtonButton $ds9(buttons).region.none \
	[string tolower [msgcat::mc {None}]] MarkerUnselectAll
    ButtonButton $ds9(buttons).region.invert \
	[string tolower [msgcat::mc {Invert}]] MarkerSelectInvert
    ButtonButton $ds9(buttons).region.delete \
	[string tolower [msgcat::mc {Delete}]] MarkerDeleteSelect
    ButtonButton $ds9(buttons).region.deleteall \
	[string tolower [msgcat::mc {Delete All}]] MarkerDeleteAllMenu

    ButtonButton $ds9(buttons).region.newgroup \
	[string tolower [msgcat::mc {New Group}]] GroupCreate
    ButtonButton $ds9(buttons).region.group \
	[string tolower [msgcat::mc {Groups}]] GroupDialog

    ButtonButton $ds9(buttons).region.list \
	[string tolower [msgcat::mc {List}]] MarkerList
    ButtonButton $ds9(buttons).region.load \
	[string tolower [msgcat::mc {Load}]] MarkerLoad
    ButtonButton $ds9(buttons).region.save \
	[string tolower [msgcat::mc {Save}]] MarkerSave
    
    CheckButton $ds9(buttons).region.show \
	[string tolower [msgcat::mc {Show}]] \
	marker(show) MarkerShow
    CheckButton $ds9(buttons).region.showtext \
	[string tolower [msgcat::mc {Show Text}]] \
	marker(show,text) MarkerShowText
    CheckButton $ds9(buttons).region.autocentroid \
	[string tolower [msgcat::mc {Auto Centroid}]] \
	marker(centroid,auto) MarkerCentroidAuto

    set buttons(region) "
        $ds9(buttons).region.info pbuttons(region,info)
        $ds9(buttons).region.circle pbuttons(region,circle)
        $ds9(buttons).region.ellipse pbuttons(region,ellipse)
        $ds9(buttons).region.box pbuttons(region,box)
        $ds9(buttons).region.polygon pbuttons(region,polygon)
        $ds9(buttons).region.line pbuttons(region,line)
        $ds9(buttons).region.vector pbuttons(region,vector)
        $ds9(buttons).region.text pbuttons(region,text)
        $ds9(buttons).region.point pbuttons(region,point)
        $ds9(buttons).region.ruler pbuttons(region,ruler)
        $ds9(buttons).region.compass pbuttons(region,compass)
        $ds9(buttons).region.projection pbuttons(region,projection)
        $ds9(buttons).region.annulus pbuttons(region,annulus)
        $ds9(buttons).region.ellipseannulus pbuttons(region,ellipseannulus)
        $ds9(buttons).region.boxannulus pbuttons(region,boxannulus)
        $ds9(buttons).region.panda pbuttons(region,panda)
        $ds9(buttons).region.epanda pbuttons(region,epanda)
        $ds9(buttons).region.bpanda pbuttons(region,bpanda)
        $ds9(buttons).region.circle3d pbuttons(region,circle3d)
        $ds9(buttons).region.create pbuttons(region,create)
        $ds9(buttons).region.dissolve pbuttons(region,dissolve)
        $ds9(buttons).region.loadtemplate pbuttons(region,loadtemplate)
        $ds9(buttons).region.savetemplate pbuttons(region,savetemplate)
        $ds9(buttons).region.centroid pbuttons(region,centroid)
        $ds9(buttons).region.front pbuttons(region,front)
        $ds9(buttons).region.back pbuttons(region,back)
        $ds9(buttons).region.all pbuttons(region,all)
        $ds9(buttons).region.none pbuttons(region,none)
        $ds9(buttons).region.invert pbuttons(region,invert)
        $ds9(buttons).region.delete pbuttons(region,delete)
        $ds9(buttons).region.deleteall pbuttons(region,deleteall)
        $ds9(buttons).region.newgroup pbuttons(region,newgroup)
        $ds9(buttons).region.group pbuttons(region,group)
        $ds9(buttons).region.list pbuttons(region,list)
        $ds9(buttons).region.load pbuttons(region,load)
        $ds9(buttons).region.save pbuttons(region,save)
        $ds9(buttons).region.show pbuttons(region,show)
        $ds9(buttons).region.showtext pbuttons(region,showtext)
        $ds9(buttons).region.autocentroid pbuttons(region,autocentroid)
    "
}

proc PrefsDialogButtonbarRegion {f} {
    global buttons
    global pbuttons

    menubutton $f -relief raised -text [msgcat::mc {Buttonbar}] -menu $f.menu
    
    set m $f.menu
    menu $m
    $m add checkbutton -label "[msgcat::mc {Get Information}]..." \
	-variable pbuttons(region,info) \
	-command {UpdateButtons buttons(region)}
    $m add separator
    $m add cascade -label [msgcat::mc {Shape}] -menu $m.shape
    $m add cascade -label [msgcat::mc {Composite Region}] -menu $m.composite
    $m add cascade -label [msgcat::mc {Template}] -menu $m.template
    $m add separator
    $m add checkbutton -label [msgcat::mc {Centroid}] \
	-variable pbuttons(region,centroid) \
	-command {UpdateButtons buttons(region)}
    $m add checkbutton -label [msgcat::mc {Move to Front}] \
	-variable pbuttons(region,front) \
	-command {UpdateButtons buttons(region)}
    $m add checkbutton -label [msgcat::mc {Move to Back}] \
	-variable pbuttons(region,back) \
	-command {UpdateButtons buttons(region)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Select All}] \
	-variable pbuttons(region,all) \
	-command {UpdateButtons buttons(region)}
    $m add checkbutton -label [msgcat::mc {Select None}] \
	-variable pbuttons(region,none) \
	-command {UpdateButtons buttons(region)}
    $m add checkbutton -label [msgcat::mc {Invert Selection}] \
	-variable pbuttons(region,invert) \
	-command {UpdateButtons buttons(region)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Delete Selected Regions}] \
	-variable pbuttons(region,delete) \
	-command {UpdateButtons buttons(region)}
    $m add checkbutton -label [msgcat::mc {Delete All Regions}] \
	-variable pbuttons(region,deleteall) \
	-command {UpdateButtons buttons(region)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {New Group}] \
	-variable pbuttons(region,newgroup) \
	-command {UpdateButtons buttons(region)}
    $m add checkbutton -label "[msgcat::mc {Groups}]..." \
	-variable pbuttons(region,group) \
	-command {UpdateButtons buttons(region)}
    $m add separator
    $m add checkbutton -label "[msgcat::mc {List Regions}]..." \
	-variable pbuttons(region,list) \
	-command {UpdateButtons buttons(region)}
    $m add checkbutton -label "[msgcat::mc {Load Regions}]..." \
	-variable pbuttons(region,load) \
	-command {UpdateButtons buttons(region)}
    $m add checkbutton -label "[msgcat::mc {Save Regions}]..." \
	-variable pbuttons(region,save) \
	-command {UpdateButtons buttons(region)}
    $m add separator
    $m add cascade -label [msgcat::mc {Region Parameters}] -menu $m.params

    menu $m.shape
    $m.shape add checkbutton -label [msgcat::mc {Circle}] \
	-variable pbuttons(region,circle) \
	-command {UpdateButtons buttons(region)}
    $m.shape add checkbutton -label [msgcat::mc {Ellipse}] \
	-variable pbuttons(region,ellipse) \
	-command {UpdateButtons buttons(region)}
    $m.shape add checkbutton -label [msgcat::mc {Box}] \
	-variable pbuttons(region,box) \
	-command {UpdateButtons buttons(region)}
    $m.shape add checkbutton -label [msgcat::mc {Polygon}] \
	-variable pbuttons(region,polygon) \
	-command {UpdateButtons buttons(region)}
    $m.shape add checkbutton -label [msgcat::mc {Line}] \
	-variable pbuttons(region,line) \
	-command {UpdateButtons buttons(region)}
    $m.shape add checkbutton -label [msgcat::mc {Vector}] \
	-variable pbuttons(region,vector) \
	-command {UpdateButtons buttons(region)}
    $m.shape add checkbutton -label [msgcat::mc {Text}] \
	-variable pbuttons(region,text) \
	-command {UpdateButtons buttons(region)}
    $m.shape add checkbutton -label [msgcat::mc {Point}] \
	-variable pbuttons(region,point) \
	-command {UpdateButtons buttons(region)}
    $m.shape add separator
    $m.shape add checkbutton -label [msgcat::mc {Ruler}] \
	-variable pbuttons(region,ruler) \
	-command {UpdateButtons buttons(region)}
    $m.shape add checkbutton -label [msgcat::mc {Compass}] \
	-variable pbuttons(region,compass) \
	-command {UpdateButtons buttons(region)}
    $m.shape add checkbutton -label [msgcat::mc {Projection}] \
	-variable pbuttons(region,projection) \
	-command {UpdateButtons buttons(region)}
    $m.shape add separator
    $m.shape add checkbutton -label [msgcat::mc {Annulus}] \
	-variable pbuttons(region,annulus) \
	-command {UpdateButtons buttons(region)}
    $m.shape add checkbutton -label [msgcat::mc {Elliptical Annulus}] \
	-variable pbuttons(region,ellipseannulus) \
	-command {UpdateButtons buttons(region)}
    $m.shape add checkbutton -label [msgcat::mc {Box Annulus}] \
	-variable pbuttons(region,boxannulus) \
	-command {UpdateButtons buttons(region)}
    $m.shape add checkbutton -label [msgcat::mc {Panda}] \
	-variable pbuttons(region,panda) \
	-command {UpdateButtons buttons(region)}
    $m.shape add checkbutton -label [msgcat::mc {Elliptical Panda}]\
	-variable pbuttons(region,epanda) \
	-command {UpdateButtons buttons(region)}
    $m.shape add checkbutton -label [msgcat::mc {Box Panda}] \
	-variable pbuttons(region,bpanda) \
	-command {UpdateButtons buttons(region)}
    $m.shape add separator
    $m.shape add checkbutton -label [msgcat::mc {Circle3d}] \
	-variable pbuttons(region,circle3d) \
	-command {UpdateButtons buttons(region)}

    menu $m.composite
    $m.composite add checkbutton -label [msgcat::mc {Create}] \
	-variable pbuttons(region,create) \
	-command {UpdateButtons buttons(region)}
    $m.composite add checkbutton -label [msgcat::mc {Dissolve}] \
	-variable pbuttons(region,dissolve) \
	-command {UpdateButtons buttons(region)}

    menu $m.template
    $m.template add checkbutton -label "[msgcat::mc {Load}]..." \
	-variable pbuttons(region,loadtemplate) \
	-command {UpdateButtons buttons(region)}
    $m.template add checkbutton -label "[msgcat::mc {Save}]..." \
	-variable pbuttons(region,savetemplate) \
	-command {UpdateButtons buttons(region)}

    menu $m.params
    $m.params add checkbutton -label [msgcat::mc {Show Regions}] \
	-variable pbuttons(region,show) \
	-command {UpdateButtons buttons(region)}
    $m.params add checkbutton -label [msgcat::mc {Show Regions Text}] \
	-variable pbuttons(region,showtext) \
	-command {UpdateButtons buttons(region)}
    $m.params add separator
    $m.params add checkbutton -label [msgcat::mc {Auto Centroid}] \
	-variable pbuttons(region,autocentroid) \
	-command {UpdateButtons buttons(region)}
}

# Support

proc UpdateRegionMenu {} {
    global current
    global marker
    global pmarker
    global ds9

    if {$current(frame) != {}} {
	$ds9(mb) entryconfig [msgcat::mc {Region}] -state normal
	$ds9(buttons).major.region configure -state normal

	set marker(show) [$current(frame) get marker show]
	set marker(show,text) [$current(frame) get marker show text]
	set marker(centroid,auto) [$current(frame) get marker centroid auto]
	set marker(preserve) [$current(frame) get marker preserve]

	switch -- $current(mode) {
	    pointer {
		if {[$current(frame) get marker select number] == 1} {
		    set marker(color) \
			[$current(frame) get marker color]
		    set marker(width) \
			[$current(frame) get marker width]
		    set marker(dash) \
			[$current(frame) get marker property dash]
		    set marker(fixed) \
			[$current(frame) get marker property fixed]
		    set marker(edit) \
			[$current(frame) get marker property edit]
		    set marker(move) \
			[$current(frame) get marker property move]
		    set marker(rotate) \
			[$current(frame) get marker property rotate]
		    set marker(delete) \
			[$current(frame) get marker property delete]
		    set marker(include) \
			[$current(frame) get marker property include]
		    set marker(source) \
			[$current(frame) get marker property source]

		    set f [$current(frame) get marker font]

		    set marker(font) [lindex $f 0]
		    set marker(font,size) [lindex $f 1]
		    set marker(font,weight) [lindex $f 2]
		    set marker(font,slant) [lindex $f 3]
		} else {
		    # defaults
		    set marker(color) $pmarker(color)
		    set marker(width) $pmarker(width) 
		    set marker(dash) $pmarker(dash) 
		    set marker(fixed) $pmarker(fixed) 
		    set marker(edit) $pmarker(edit) 
		    set marker(move) $pmarker(move) 
		    set marker(rotate) $pmarker(rotate) 
		    set marker(delete) $pmarker(delete) 
		    set marker(include) $pmarker(include) 
		    set marker(source) $pmarker(source) 

		    set marker(font) $pmarker(font) 
		    set marker(font,size) $pmarker(font,size) 
		    set marker(font,weight) $pmarker(font,weight) 
		    set marker(font,slant) $pmarker(font,slant) 
		}
	    }
	}
    } else {
	$ds9(mb) entryconfig [msgcat::mc {Region}] -state disabled
	$ds9(buttons).major.region configure -state disabled
    }
}
