#  Copyright (C) 1999-2010
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc PointDialog {varname} {
    upvar #0 $varname var
    global $varname

    # see if we already have a header window visible
    if [winfo exists $var(top)] {
	raise $var(top)
	return
    }

    # procs
    set var(which) point
    set var(proc,apply) PointApply
    set var(proc,close) PointClose
    set var(proc,coordCB) PointCoordCB

    # base
    MarkerBaseCenterDialog $varname 375 100

    # init
    set var(size) [$var(frame) get marker $var(id) point size]

    # size
    label $var(top).ref.f.sizeTitle -text [msgcat::mc {Size}]
    entry $var(top).ref.f.size -textvariable ${varname}(size) -width 13 
    label $var(top).ref.f.sizeformat -text [msgcat::mc {Pixels}] -padx 4
    grid $var(top).ref.f.sizeTitle $var(top).ref.f.size x \
	$var(top).ref.f.sizeformat -padx 4 -sticky w
}

# actions

proc PointClose {varname} {
    upvar #0 $varname var
    global $varname

    MarkerBaseCenterClose $varname
}

proc PointApply {varname} {
    upvar #0 $varname var
    global $varname

    $var(frame) marker $var(id) point size $var(size)

    MarkerBaseCenterApply $varname
}

# callbacks

proc PointCoordCB {varname {dummy {}}} {
    upvar #0 $varname var
    global $varname

    global debug
    if {$debug(tcl,marker)} {
	puts stderr "PointCoordCB"
    }

    MarkerBaseCoordCB $varname
    MarkerBaseCenterMoveCB $varname
}





