#! /bin/sh

echo "GLON Tests"

echo "Starting DS9..."
if [ `xpaaccess ds9` = no ]; then
    ds9 &

    i=1
    while [ "$i" -le 30 ]
	do
	sleep 2
	if [ `xpaaccess ds9` = yes ]; then
	    break
	fi

	i=`expr $i + 1`
    done
fi

testit () {
    echo "Testing $1"
    xpaset -p ds9 file $1
    xpaset -p ds9 wcs sky fk5
    xpaset -p ds9 align yes
    read
    xpaset -p ds9 wcs sky galactic
    read
    xpaset -p ds9 frame clear
}

# load default image
xpaset -p ds9 grid yes
xpaset -p ds9 wcs skyformat deg

echo "GLON-CAR correct"
testit GLM_00350+0115_mosaic_I4_cutout_14706.fits
testit GLM_03350+0000_mosaic_I1_cutout_10617.fits
testit car_01.fits

testit GP_343.5_+0.0_A.fits
testit iras_hires_band3.fits
testit iras_hires_band3_inn.fits
testit msxmapA-1a.fits
testit msxmapA-2.fits

#echo "GLON-CAR incorrect"
#testit eta.fits
#testit msx327p5.fits
#testit msxmapA-1.fits
#testit rmon_msxmapA.fits

#echo "RA-CAR incorrect"
#testit car_02.fits

echo "GLON-ZEA correct"
testit SFD_dust_4096_sgp.fits
testit South_galactic.fits

#echo "GLON-ZEA incorrect"
#testit SFD_dust_4096_ngp.fits
#testit North_galactic.fits

xpaset -p ds9 quit


