#! /bin/sh

echo "Print Tests"

echo "Starting DS9..."
if [ `xpaaccess ds9` = no ]; then
    ds9&

    i=1
    while [ "$i" -le 30 ]
	do
	sleep 2
	if [ `xpaaccess ds9` = yes ]; then
	    break
	fi

	i=`expr $i + 1`
    done
fi

doit() {
    echo $1
    xpaset -p ds9 print palette $2
    xpaset -p ds9 print level $3
    xpaset -p ds9 print
}

xpaset -p ds9 scale zscale
xpaset -p ds9 print command '{gv -}'
xpaset -p ds9 grid
#xpaset -p ds9 contour

if [ "$1" = "single" -o  -z "$1" ]; then
echo "Testing Single"

xpaset -p ds9 file img16.fits
xpaset -p ds9 regions load ds9.fk5.hms.reg

doit "..RGB Level 2" rgb 2
doit "..CMYK Level 2" cmyk 2
doit "..Gray Level 2" gray 2

doit "..RGB Level 1" rgb 1
doit "..Gray Level 1" gray 1

echo "PASSED"
fi

if [ "$1" = "mosaic" -o  -z "$1" ]; then
echo "Testing Mosaic"

xpaset -p ds9 file mosaicimageiraf mosaicimage.fits
xpaset -p ds9 regions load ds9.mosaic.fk5.hms.reg

doit "..RGB Level 2" rgb 2
doit "..CMYK Level 2" cmyk 2
doit "..Gray Level 2" gray 2

doit "..RGB Level 1" rgb 1
doit "..Gray Level 1" gray 1

echo "PASSED"
fi

if [ "$1" = "rgb" -o  -z "$1" ]; then
echo "Testing RGB"

xpaset -p ds9 rgb
xpaset -p ds9 file rgbcube rgbcube.fits

doit "..RGB Level 2" rgb 2
doit "..CMYK Level 2" cmyk 2
doit "..Gray Level 2" gray 2

doit "..RGB Level 1" rgb 1
doit "..Gray Level 1" gray 1

echo "PASSED"
fi

echo "DONE"

if [ -z "$1" ]; then
xpaset -p ds9 quit
fi

