// Copyright (C) 1999-2010
// Smithsonian Astrophysical Observatory, Cambridge, MA, USA
// For conditions of distribution and use, see copyright notice in "copyright"

#ifndef __xxlib_h__
#define __xxlib_h__

#include <tcl.h>
#include <tk.h>

// direct X11 to Tk

extern "C" {

  // New Routines

  void XDrawString(Display* display, Drawable drawable, GC gc, 
		   int x, int y, _Xconst char* str, int length);

  void XFreePixmap(Display* display, Pixmap pixmap);

  Pixmap XCreatePixmap(Display* display, Drawable drawable, 
		       unsigned int width, unsigned int height,
		       unsigned int depth);

  Status XGetGCValues(Display* disp,GC gc, unsigned long mask, XGCValues* ret);

  void XCopyGC(Display* display, GC src, unsigned long mask, GC dest);

  // Redefined Routines

  void XXWarpPointer(Display* display, Window src_w, Window dest_w,
		     int src_x, int src_y,
		     unsigned int src_width, unsigned int src_height,
		     int dest_x, int dest_y);

  Bool XXQueryPointer(Display* display, Window w, 
		      Window* root_return, Window* child_return, 
		      int* root_x_return, int* root_y_return, 
		      int* win_x_return, int* win_y_return, 
		      unsigned int* mask_return);

  void XXPutImage(Display* display, Drawable d, GC gc, XImage* image,
		  int src_x, int src_y, int dest_x, int dest_y,
		  unsigned int width, unsigned int height);

  XImage* XXGetImage(Display* display, Drawable drawable, int x, int y,
		     unsigned int width, unsigned int height,
		     unsigned long plane, int format);

  // Not Supported

  inline void XSetClipRectangles(Display* display, GC gc, int clip_x_origin,
				 int  clip_y_origin, XRectangle* r,
				 int  n, int  ordering) {}

  inline void XInstallColormap(Display* display, Colormap colormap) {}

  inline Status XAllocColorCells(Display* display, Colormap xcmap, Bool contig,
				 unsigned long *planes_mask, 
				 unsigned int nplanes, unsigned long *pixels,
				 unsigned int ncolors) {}

  inline void XStoreColors(Display* display, Colormap xcmap, XColor* color,
			   int ncolors) {}
}

#endif
